"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  BodyScrollLockDirective: () => BodyScrollLockDirective,
  CScrollLock: () => CScrollLock,
  useBodyScrollLock: () => useBodyScrollLock
});
module.exports = __toCommonJS(src_exports);

// src/c-scroll-lock.ts
var import_vue2 = require("vue");

// src/body-scoll-lock.directive.ts
var import_vue = require("vue");
var import_body_scroll_lock = require("body-scroll-lock");
var BodyScrollLockDirective = {
  mounted(el, binding) {
    if (el && binding.value) {
      (0, import_body_scroll_lock.disableBodyScroll)(el);
    } else if (el && !binding.value) {
      (0, import_body_scroll_lock.enableBodyScroll)(el);
    }
  },
  updated(el, binding) {
    if (el && binding.value) {
      (0, import_body_scroll_lock.disableBodyScroll)(el);
    } else if (el && !binding.value) {
      (0, import_body_scroll_lock.enableBodyScroll)(el);
    }
  },
  unmounted(el, binding) {
    if (el) {
      (0, import_body_scroll_lock.enableBodyScroll)(el);
    }
  }
};

// src/c-scroll-lock.ts
var CScrollLock = (0, import_vue2.defineComponent)({
  name: "CScrollLock",
  props: {
    enabled: {
      type: Boolean,
      default: false
    }
  },
  setup(props, {
    slots,
    attrs
  }) {
    return () => {
      var _a;
      const [firstChild] = (_a = slots.default) == null ? void 0 : _a.call(slots, {});
      if (!firstChild) {
        console.warn(`[chakra-ui:focus-lock]: Focus lock component expects at least and only one child element.`);
        return;
      }
      const scrollLockVNode = (0, import_vue2.cloneVNode)(firstChild, {
        ...attrs,
        "data-chakra-scroll-lock": `${props.enabled}`
      });
      return (0, import_vue2.withDirectives)(scrollLockVNode, [[BodyScrollLockDirective, props.enabled]]);
    };
  }
});

// src/use-body-scoll-lock.ts
var import_body_scroll_lock2 = require("body-scroll-lock");
var import_vue3 = require("vue");
var import_vue_utils = require("@chakra-ui/vue-utils");
function useBodyScrollLock(enable, options) {
  const [scrollLockRef, scrollLockEl] = (0, import_vue_utils.useRef)();
  (0, import_vue3.watch)([scrollLockEl, enable], ([target, isActive], [previousTarget]) => {
    if (!target || !enable.value) {
      previousTarget && (0, import_body_scroll_lock2.enableBodyScroll)(previousTarget);
    } else if (target && isActive) {
      (0, import_body_scroll_lock2.disableBodyScroll)(target, options);
    } else {
      (0, import_body_scroll_lock2.enableBodyScroll)(target);
    }
  }, {
    immediate: true,
    flush: "post"
  });
  return {
    scrollLockRef
  };
}
__name(useBodyScrollLock, "useBodyScrollLock");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BodyScrollLockDirective,
  CScrollLock,
  useBodyScrollLock
});
